namespace TestLibrary;

/// <summary>
/// ڵ  ̽
/// </summary>
public abstract class CodeColorizerBase
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region Field

    /// <summary>
    /// Ÿ ųʸ
    /// </summary>
    public readonly StyleDictionary StyleDictionary;

    #endregion

    ////////////////////////////////////////////////////////////////////////////////////////// Protected

    #region Field

    /// <summary>
    ///  ļ ̽
    /// </summary>
    protected readonly ILanguageParser languageParser;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - CodeColorizerBase(styleDictionary, languageParser)

    /// <summary>
    /// 
    /// </summary>
    /// <param name="styleDictionary">Ÿ ųʸ</param>
    /// <param name="languageParser"> ļ</param>
    public CodeColorizerBase(StyleDictionary styleDictionary, ILanguageParser languageParser)
    {
        this.languageParser = languageParser ?? new LanguageParser(new LanguageCompiler(LanguageHelper.CompiledLanguageDictionary, LanguageHelper.CompileReaderWriterLockSlim), LanguageHelper.LanguageRepository);

        StyleDictionary = styleDictionary ?? StyleDictionary.DefaultLight;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Protected

    #region  - Write(parsedSourceCode, scopeList)

    /// <summary>
    /// 
    /// </summary>
    /// <param name="parsedSourceCode">Ľ̵ ҽ ڵ</param>
    /// <param name="scopeList"> Ʈ</param>
    protected abstract void Write(string parsedSourceCode, IList<Scope> scopeList);

    #endregion
}