namespace TestLibrary;

/// <summary>
/// Ģ 
/// </summary>
public static class RuleFormat
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region Field

    /// <summary>
    /// ڹ ũƮ
    /// </summary>
    public static string JavaScript;

    /// <summary>
    ///  ũƮ
    /// </summary>
    public static string ServerScript;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Static

    #region  - RuleFormat()

    /// <summary>
    /// 
    /// </summary>
    static RuleFormat()
    {
        const string scriptRegularExpressionString = @"(?xs)(<)(script){0}[\s\n]+({1})[\s\n]*(=)[\s\n]*(""{2}""){0}[\s\n]*(>)(.*?)(</)(script)(>)";

        const string attributeRegularExpressionString = @"(?:[\s\n]+([a-z0-9-_]+)[\s\n]*(=)[\s\n]*([^\s\n""']+?)|[\s\n]+([a-z0-9-_]+)[\s\n]*(=)[\s\n]*(""[^\n]+?"")|[\s\n]+([a-z0-9-_]+)[\s\n]*(=)[\s\n]*('[^\n]+?')|[\s\n]+([a-z0-9-_]+) )*";

        JavaScript   = string.Format(scriptRegularExpressionString, attributeRegularExpressionString, "type|language", "[^\n]*javascript");
        ServerScript = string.Format(scriptRegularExpressionString, attributeRegularExpressionString, "runat"        , "server"          );
    }

    #endregion
}