namespace TestLibrary;

/// <summary>
///  Ģ
/// </summary>
public class LanguageRule
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  ǥ - RegularExpression

    /// <summary>
    ///  ǥ
    /// </summary>
    public string RegularExpression { get; private set; }

    #endregion
    #region ĸó ųʸ - CaptureDictionary

    /// <summary>
    /// ĸó ųʸ
    /// </summary>
    public IDictionary<int, string> CaptureDictionary { get; private set; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - LanguageRule(regularExpression, captureDictionary)

    /// <summary>
    /// 
    /// </summary>
    /// <param name="regularExpression"> ǥ</param>
    /// <param name="captureDictionary">ĸó ųʸ</param>
    public LanguageRule(string regularExpression, IDictionary<int, string> captureDictionary)
    {
        ArgumentHelper.EnsureIsNotNullAndNotEmpty(regularExpression, "regularExpression");
        ArgumentHelper.EnsureIsNotNullAndNotEmpty(captureDictionary, "captureDictionary");

        RegularExpression = regularExpression;
        CaptureDictionary = captureDictionary;
    }

    #endregion
}