namespace TestLibrary;

/// <summary>
///  Ȯ
/// </summary>
public static class SortExtension
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Public

    #region  ϱ - SortStable<T>(list, comparison)

    /// <summary>
    ///  ϱ
    /// </summary>
    /// <typeparam name="T"> Ÿ</typeparam>
    /// <param name="list">Ʈ ̽</param>
    /// <param name="comparison"> Ʈ</param>
    public static void SortStable<T>(this IList<T> list, Comparison<T> comparison)
    {
        ArgumentHelper.EnsureIsNotNull(list, "list");

        int count = list.Count;

        for(int j = 1; j < count; j++)
        {
            T key = list[j];

            int i = j - 1;

            for(; i >= 0 && comparison(list[i], key) > 0; i--)
            {
                list[i + 1] = list[i];
            }

            list[i + 1] = key;
        }
    }

    #endregion
}