namespace TestLibrary;

/// <summary>
/// 
/// </summary>
public class Scope
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - Name

    /// <summary>
    /// 
    /// </summary>
    public string Name { get; set; }

    #endregion
    #region ε - Index

    /// <summary>
    /// ε
    /// </summary>
    public int Index { get; set; }

    #endregion
    #region  - Length

    /// <summary>
    /// 
    /// </summary>
    public int Length { get; set; }

    #endregion
    #region θ  - ParentScope

    /// <summary>
    /// θ 
    /// </summary>
    public Scope ParentScope { get; set; }

    #endregion
    #region ڽ  Ʈ - ChildScopeList

    /// <summary>
    /// ڽ  Ʈ
    /// </summary>
    public IList<Scope> ChildScopeList { get; set; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - Scope(name, index, length)

    /// <summary>
    /// 
    /// </summary>
    /// <param name="name"></param>
    /// <param name="index">ε</param>
    /// <param name="length"></param>
    public Scope(string name, int index, int length)
    {
        ArgumentHelper.EnsureIsNotNullAndNotEmpty(name, "name");
        
        Name            = name;
        Index           = index;
        Length          = length;
        ChildScopeList = new List<Scope>();
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ڽ ߰ϱ - AddChild(childScope)

    /// <summary>
    /// ڽ ߰ϱ
    /// </summary>
    /// <param name="childScope">ڽ </param>
    public void AddChild(Scope childScope)
    {
        if(childScope.ParentScope != null)
        {
            throw new InvalidOperationException("The child scope already has a parent.");
        }

        childScope.ParentScope = this;

        ChildScopeList.Add(childScope);
    }

    #endregion
}