using System.Collections.ObjectModel;

namespace TestLibrary;

/// <summary>
/// Ÿ ųʸ
/// </summary>
public partial class StyleDictionary : KeyedCollection<string, Style>
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region Field

    public const string Blue           = "#ff0000ff";
    public const string White          = "#ffffffff";
    public const string Black          = "#ff000000";
    public const string DullRed        = "#ffa31515";
    public const string Yellow         = "#ffffff00";
    public const string Green          = "#ff008000";
    public const string PowderBlue     = "#ffb0e0e6";
    public const string Teal           = "#ff008080";
    public const string Gray           = "#ff808080";
    public const string Navy           = "#ff000080";
    public const string OrangeRed      = "#ffff4500";
    public const string Purple         = "#ff800080";
    public const string Red            = "#ffff0000";
    public const string MediumTurqoise = "#ff48d1cc";
    public const string Magenta        = "#ffff00ff";
    public const string OliveDrab      = "#ff6b8e23";
    public const string DarkOliveGreen = "#ff556b2f";
    public const string DarkCyan       = "#ff008b8b";
    public const string DarkOrange     = "#ffff8700";
    public const string BrightGreen    = "#ff00d700";
    public const string BrightPurple   = "#ffaf87ff";

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Protected

    #region ׸ Ű ϱ - GetKeyForItem(style)

    /// <summary>
    /// ׸ Ű ϱ
    /// </summary>
    /// <param name="style">Ÿ</param>
    /// <returns>׸ Ű</returns>
    protected override string GetKeyForItem(Style style)
    {
        return style.ScopeName;
    }

    #endregion
}